﻿using System;
using System.Collections.Generic;
using System.Linq;
using JSLintForResharper.JSLint;
using NUnit.Framework;

namespace JSLintForResharper.Tests.JSLint
{
	[TestFixture]
	public class ScriptRunnerTests
	{
		[Test]
		public void Evaluate_ReturnsLintWarnings()
		{
			var expectedWarnings = LintWarningList.ParseAll(
@"1	1	'one' was used before it was defined.	one
1	1	Expected an assignment or function call and instead saw an expression.	one
1	4	Expected ';' and instead saw 'two'.	one
2	1	'two' was used before it was defined.	two
2	1	Expected an assignment or function call and instead saw an expression.	two
2	4	Expected ';' and instead saw '(end)'.	two
"
			);

			const string input = "one\ntwo";
			const string options = "{'indent':'1'}";
			var output = ScriptRunner.Evaluate(input, options);
			Assert.That(expectedWarnings.SequenceEqual(output), expectedWarnings + "---" + output);
		}
	}
}
